diff --git a/src/tui/tools/bb-update-template.ts b/src/tui/tools/bb-update-template.ts
new file mode 100644
index 0000000..3a50cfe
--- /dev/null
+++ b/src/tui/tools/bb-update-template.ts
@@ -0,0 +1,96 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { saveTemplate, getTemplates, getAgentTypes } from '../../lib/server/beads-fs';
+
+const TeamMemberSchema = Type.Object({
+  agentTypeId: Type.Optional(Type.String({ description: 'Agent type ID for this team member' })),
+  archetypeId: Type.Optional(Type.String({ description: 'DEPRECATED: Use agentTypeId instead' })),
+  count: Type.Number({ description: 'Number of workers of this type' }),
+});
+
+export function createUpdateTemplateTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_update_template',
+    label: 'Update Swarm Template',
+    description: 'Update an existing swarm template. Provide the ID and fields to update.',
+    parameters: Type.Object({
+      id: Type.String({ description: 'Template ID to update' }),
+      name: Type.Optional(Type.String({ description: 'New display name' })),
+      description: Type.Optional(Type.String({ description: 'New description' })),
+      team: Type.Optional(Type.Array(TeamMemberSchema, { description: 'New team composition' })),
+      color: Type.Optional(Type.String({ description: 'New hex color' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { id, name, description, team, color } = params;
+
+        if (!id || typeof id !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: id is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Check if template exists
+        const templates = await getTemplates();
+        const existing = templates.find(t => t.id === id);
+
+        if (!existing) {
+          return {
+            content: [{ type: 'text', text: `Error: Template "${id}" not found.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Validate agent type IDs if team is being updated
+        if (team) {
+          const agentTypes = await getAgentTypes();
+          const validIds = new Set(agentTypes.map(a => a.id));
+
+          for (const member of team) {
+            const agentTypeId = member.agentTypeId || member.archetypeId;
+            if (!agentTypeId || !validIds.has(agentTypeId)) {
+              return {
+                content: [{ type: 'text', text: `Error: Unknown agent type "${agentTypeId}".` }],
+                isError: true,
+                details: {},
+              };
+            }
+          }
+        }
+
+        // Merge with existing values
+        const updated = await saveTemplate({
+          id,
+          name: name ?? existing.name,
+          description: description ?? existing.description,
+          team: team ?? existing.team,
+          color: color ?? existing.color,
+        });
+
+        const teamDesc = updated.team.map(m => `${m.count}x ${m.agentTypeId}`).join(', ');
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Swarm template updated successfully!
+
+ID: ${updated.id}
+Name: ${updated.name}
+Team: ${teamDesc}`,
+          }],
+          details: { template: updated },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to update template: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-worker-results.ts b/src/tui/tools/bb-worker-results.ts
new file mode 100644
index 0000000..3cbd28b
--- /dev/null
+++ b/src/tui/tools/bb-worker-results.ts
@@ -0,0 +1,116 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { workerSessionManager } from '../../lib/worker-session-manager';
+import { execFileSync } from 'child_process';
+
+/**
+ * Get results from completed workers.
+ * 
+ * For each completed worker, returns:
+ * - Worker metadata (display name, type, status)
+ * - Bead summary (from close reason)
+ * - Suggestion to read actual files for verification
+ */
+export function createWorkerResultsTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_worker_results',
+    label: 'Get Worker Results',
+    description: `Get results from completed workers. Shows bead summary and suggests files to read.
+
+Usage:
+- bb_worker_results() - get all completed worker results
+- bb_worker_results(worker_ids: ["worker-123", "worker-456"]) - specific workers
+
+After getting results, READ THE ACTUAL FILES to verify and understand the work.
+The bead summary is high-level; the files show the real implementation.`,
+    parameters: Type.Object({
+      worker_ids: Type.Optional(Type.Array(Type.String(), {
+        description: 'Optional: specific worker IDs to get results for. If not provided, returns all completed workers.'
+      })),
+    }),
+    async execute(_toolCallId: string, params: unknown): Promise<any> {
+      const { worker_ids } = params as { worker_ids?: string[] };
+
+      try {
+        const workers = workerSessionManager.getAllWorkers();
+        
+        // Filter to completed workers
+        let completedWorkers = workers.filter(w => w.status === 'completed' || w.status === 'failed');
+        
+        // Filter to specific IDs if provided
+        if (worker_ids && worker_ids.length > 0) {
+          completedWorkers = completedWorkers.filter(w => worker_ids.includes(w.id));
+        }
+
+        if (completedWorkers.length === 0) {
+          return {
+            content: [{ type: 'text', text: 'No completed workers found. Use bb_worker_status to see active workers.' }],
+          };
+        }
+
+        // Build results by reading beads
+        const results: string[] = [];
+        
+        for (const worker of completedWorkers) {
+          const statusIcon = worker.status === 'completed' ? '✓' : '✗';
+          const errorSection = worker.error ? `\n   Error: ${worker.error}` : '';
+          
+          // Try to read the bead for summary
+          let beadSummary = '';
+          if (worker.beadId) {
+            try {
+              const beadOutput = execFileSync('bd', ['show', worker.beadId], {
+                cwd: projectRoot,
+                encoding: 'utf-8',
+                timeout: 5000,
+              });
+              
+              // Extract close reason or notes
+              const lines = beadOutput.split('\n');
+              const closeReasonLine = lines.find(l => l.toLowerCase().includes('close') || l.toLowerCase().includes('reason'));
+              const notesLine = lines.find(l => l.toLowerCase().includes('notes'));
+              
+              if (closeReasonLine) {
+                beadSummary = `\n   Summary: ${closeReasonLine.split(':').slice(1).join(':').trim()}`;
+              } else if (notesLine) {
+                beadSummary = `\n   Notes: ${notesLine.split(':').slice(1).join(':').trim()}`;
+              }
+            } catch {
+              beadSummary = `\n   Bead: ${worker.beadId} (could not read details)`;
+            }
+          }
+
+          results.push(`${statusIcon} **${worker.displayName || worker.id}** (${worker.agentTypeId || 'default'})
+   Status: ${worker.status}
+   Bead: ${worker.beadId || 'none'}${beadSummary}${errorSection}`);
+        }
+
+        const summary = `## Worker Results (${completedWorkers.length} completed)
+
+${results.join('\n\n')}
+
+---
+**Next step:** Read the actual files the workers touched to verify and understand the implementation. Use the read tool on relevant files.`;
+
+        return {
+          content: [{ type: 'text', text: summary }],
+          details: {
+            workers: completedWorkers.map(w => ({
+              id: w.id,
+              displayName: w.displayName,
+              beadId: w.beadId,
+              status: w.status,
+              agentTypeId: w.agentTypeId,
+            })),
+          },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to get worker results: ${message}` }],
+          isError: true,
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-worker-status.ts b/src/tui/tools/bb-worker-status.ts
new file mode 100644
index 0000000..c1ec480
--- /dev/null
+++ b/src/tui/tools/bb-worker-status.ts
@@ -0,0 +1,107 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { workerSessionManager } from '../../lib/worker-session-manager';
+
+export function createWorkerStatusTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_worker_status',
+    label: 'Check Worker Status',
+    description: 'Check the status of a spawned worker agent. Use this to see if a worker is still working, completed successfully, or failed.',
+    parameters: Type.Object({
+      worker_id: Type.String({ description: 'The ID of the worker to check (returned by bb_spawn_worker)' }),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { worker_id } = params;
+
+        console.log(`[bb_worker_status] Checking status for worker ${worker_id}`);
+
+        // Validate required param
+        if (!worker_id || typeof worker_id !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: worker_id is required and must be a string.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Get worker from manager
+        const worker = workerSessionManager.getWorker(worker_id);
+
+        if (!worker) {
+          return {
+            content: [{ type: 'text', text: `Worker ${worker_id} not found. It may not exist or has already been cleaned up.` }],
+            isError: true,
+            details: { workerId: worker_id },
+          };
+        }
+
+        // Build status report
+        const statusEmoji = {
+          spawning: '🔄',
+          working: '🔨',
+          completed: '✅',
+          failed: '❌',
+        };
+
+        let statusMessage = `${statusEmoji[worker.status]} ${worker.status.toUpperCase()}`;
+
+        let details = `Task: ${worker.taskId}
+Created: ${worker.createdAt}
+`;
+
+        if (worker.completedAt) {
+          details += `Completed: ${worker.completedAt}
+`;
+        }
+
+        if (worker.result) {
+          details += `
+Result:
+${worker.result}
+`;
+        }
+
+        if (worker.error) {
+          details += `
+Error: ${worker.error}
+`;
+        }
+
+        // If working, add hint about waiting
+        if (worker.status === 'working') {
+          details += `
+Worker is currently executing. Check again later for completion status.`;
+        }
+
+        // If completed, offer to get more details
+        if (worker.status === 'completed') {
+          details += `
+Use this worker's result in your orchestration decisions. The worker has reported back and is no longer active.`;
+        }
+
+        return {
+          content: [{ type: 'text', text: statusMessage }],
+          details: {
+            workerId: worker.id,
+            taskId: worker.taskId,
+            status: worker.status,
+            createdAt: worker.createdAt,
+            completedAt: worker.completedAt,
+            hasResult: !!worker.result,
+            hasError: !!worker.error,
+          },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        console.error(`[bb_worker_status] Error:`, message);
+
+        return {
+          content: [{ type: 'text', text: `Failed to check worker status: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/types.ts b/src/tui/tools/types.ts
new file mode 100644
index 0000000..81d2365
--- /dev/null
+++ b/src/tui/tools/types.ts
@@ -0,0 +1,9 @@
+/**
+ * Re-export Pi SDK tool types for BeadBoard TUI tools.
+ * 
+ * We use ToolDefinition from the Pi SDK, which requires:
+ * - name, label, description, parameters (TypeBox schema)
+ * - execute(toolCallId, params, signal, onUpdate, ctx) => Promise<AgentToolResult>
+ */
+export type { ToolDefinition as CustomAgentTool, AgentToolResult, ExtensionContext } from '@mariozechner/pi-coding-agent';
+export { Type } from '@sinclair/typebox';
